#!/usr/bin/python
# -*- coding: UTF-8 -*-
# 08.05.2016

# Wird nur beim Anlegen einer neuen Projektdatei benötigt
# Liest die Einstellungen aus einer XML-Datei aus

from xml.sax import make_parser, handler


def xml_read(file):
    parser = make_parser()
    b = MyObjektHandler()
    parser.setContentHandler(b)
    parser.parse(file)
    return b.config, b.konten


class MyObjektHandler(handler.ContentHandler):
    def __init__(self):
        handler.ContentHandler.__init__(self)
        self.config = []
        self.konten = []
        self.name = ""
        self.konto_id = ""
        self.ausgabe_brutto = "0"
        self.ust = "19"
        self.ust_1 = ""
        self.ust_2 = ""
        self.zeilen_pro_seite = ""
        self.current_content = ""

    def startElement(self, name, attrs):
        # print(name)
        if name in ("konto", "configuration"):
            self.name = ""
            self.konto_id = ""
            self.ust = ""

    def characters(self, content):
        content = content.strip()
        if len(content):
            self.current_content += content

    def endElement(self, name):
        if name == "konto_id":
            self.konto_id = self.current_content
           
        elif name == "name":
            self.name = self.current_content

        elif name == "ausgabe_brutto":
            self.ausgabe_brutto = self.current_content

        elif name == "umsatzsteuer_ermaessigt":
            self.ust_1 = self.current_content

        elif name == "umsatzsteuer":
            self.ust_2 = self.current_content

        elif name == "ust":
            self.ust = self.current_content

        elif name == "zeilen_pro_seite":
            self.zeilen_pro_seite = self.current_content

        elif name == "konto":
            self.konten.append((self.konto_id, self.ust, self.name))

        elif name == "configuration":
            # Das Buchungsjahr wird via Dialog nachgeliefert
            # hier wird nur ein Platzhalter verwendet, der später überschrieben wird.
            self.config.append(("buchungsjahr", 99))
            self.config.append(("ust_1", self.ust_1))
            self.config.append(("ust_2", self.ust_2))
            self.config.append(("zeilen_pro_seite", self.zeilen_pro_seite))
            self.config.append(("brutto_ausgabe", self.ausgabe_brutto))

        elif name == "projekt":
            pass

        else:
            print("nicht behandelter Tag: {}".format(name))

        self.current_content = ""


if __name__ == "__main__":
    for i in xml_read("./config.xml"):
        print(i)